libname marfin 'c:\data\MRFSS\MARFIN';
data dolphin; set marfin.dolphin3;
 
/* linear conditional logit */
proc mdc data=dolphin type = clogit outest=estimates1 covout;
model y = tcfee pbig psmall bigame lognsite /
choice = (site 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 
               29 30 31 32 33 34);
id id;
run;

/* linear nested logit */
proc mdc data=dolphin type = nlogit outest=estimates2 covout;
model y = tcfee pbig psmall bigame lognsite /  samescale 
choice = (site 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 
               29 30 31 32 33 34);
id id;
utility u(1, ) = tcfee pbig psmall bigame lognsite;
nest level(1) = (1 2 3 4 5 6 7 8 @ 1, 9 10 11 12 13 14 15 16 17 18 @ 2,
                 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 @ 3), 
     level(2) = (1 2 3 @ 1);
run;                                                                                                                                                                                                                                                        

/* need to make one more change to program below */

* clean up the parms dataset;                                                                                                           
                                                                                                                                        
               

/* Krinsky-Robb for CL */ 
data beta1 (drop=_status_ _depvar_ _method_ _name_ _model_ _type_ _liklhd_ _stderr_);                                                    
set estimates1 ;                                                                                                                          
if _type_='PARMS';    

                                                                                                                                                                                                                                                                      

data covmat1 (drop=_status_ _depvar_ _method_ _name_ _model_ _type_ _liklhd_ _stderr_);                                                  
set estimates1;                                                                                                                          
if _type_='COV';                                                                                                                        
run;                

%let draws=1000;                                                                                                                                                                                                                                                             

proc iml;                                                                                                                               
use covmat1;                                                                                                                             
read all var _num_ into et;                                                                                                             
use beta1;                                                                                                                               
read all var _num_ into mu;                                                                                                             
CALL VNORMAL( series, mu, et, &draws , 238673232);                                                                                      
create parms from series;                                                                
append from series;                                                                                                                     
close parms;                                                                                                                            
                                               
/* mwtp_ij, i = model, j = species */ 
data marginal_value1 (keep=mwtp_11 mwtp_12 mwtp_13);                                                                                 
set parms;                                                                                                                              
mwtp_11=-1*col2/col1;                                                                                                                
mwtp_12=-1*col3/col1;                                                                                                                 
mwtp_13=-1*col4/col1;                                                                                                              
proc means;                                                                                                                             
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value1;                                                                                                          
by mwtp_11;                                                                                                                          
run;                                                                                                                                    
                                                                                                                                        
data fish1;                                                                                                                             
set marginal_value1;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_11;                                                                                                             
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value1;                                                                                                          
by mwtp_12;                                                                                                                           
run;                                                                                                                                    
                                                                                                                                        
data fish2;                                                                                                                              
set marginal_value1;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_12;                                                                                                              
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value1;                                                                                                          
by mwtp_13;                                                                                                                        
run;                                                                                                                                    
                                                                                                                                        
data fish3;                                                                                                                           
set marginal_value1;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_13;                                                                                                           
run;   

                                                                                                                                                                                                                                                            

/* Krinsky-Robb for NL */
%let draws=1000; 
data beta2 (drop=_status_ _depvar_ _method_ _name_ _model_ _type_ _liklhd_ _stderr_);                                                    
set  estimates2;                                                                                                                          
if _type_='PARMS';     
run;  
data covmat2 (drop=_status_ _depvar_ _method_ _name_ _model_ _type_ _liklhd_ _stderr_);                                                  
set estimates2;                                                                                                                          
if _type_='COV';   
run;
proc iml;                                                                                                                               
use covmat2;                                                                                                                             
read all var _num_ into et;                                                                                                             
use beta2;                                                                                                                               
read all var _num_ into mu;                                                                                                             
CALL VNORMAL( series, mu, et, &draws , 238673232);                                                                                      
create parms from series;                                                                
append from series;                                                                                                                     
close parms;                                                                                                                            
                                                                                                                                        
data marginal_value2 (keep=mwtp_21 mwtp_22 mwtp_23);                                                                                 
set parms;                                                                                                                              
mwtp_21=-1*col2/col1;                                                                                                              
mwtp_22=-1*col3/col1;                                                                                                                 
mwtp_23=-1*col4/col1;                                                                                                              
proc means;                                                                                                                             
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value2;                                                                                                          
by mwtp_21;                                                                                                                          
run;                                                                                                                                    
                                                                                                                                        
data small2;                                                                                                                             
set marginal_value2;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_21;                                                                                                             
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value2;                                                                                                          
by mwtp_22;                                                                                                                           
run;                                                                                                                                    
                                                                                                                                        
data king1;                                                                                                                              
set marginal_value2;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_22;                                                                                                              
run;                                                                                                                                    
                                                                                                                                        
proc sort data=marginal_value2;                                                                                                          
by mwtp_23;                                                                                                                        
run;                                                                                                                                    
                                                                                                                                        
data spanish;                                                                                                                           
set marginal_value2;                                                                                                                     
* picks off 95% CI for small;                                                                                                           
if _n_=25 or _n_=975;                                                                                                                   
proc print; var mwtp_23;                                                                                                           
run; 

 
/*                                                                                                                                      
**                                                                                                                                      
**                                                                                                                                      
**  This part does RMSE                                                                                                                 
**                                                                                                                                      
**                                                                                                                                      
*/                                                                                                                                      
* ok, now calculate predicted probabilities for each observation;                                                                       
data dolphin_1;                                                                                                                        
set dolphin;                                                                                                                        
inmerge=1;                                                                                                                              
proc sort; by inmerge;                                                                                                                  
run;
/* NEED TO CHANGE SPECIES NAMES IN EU EQUATIONS!!!!! */  
data beta_1 (drop=tcfee pbig psmall bigame lognsite);  
set beta1;
b_tc1=tcfee;                                                                                                                                
b_fish11=pbig;                                                                                                                          
b_fish12=psmall;                                                                                                                            
b_fish13=bigame;                                                                                                                      
b_lsite1=lognsite;      
inmerge=1;   
proc sort; by inmerge;                                                                                                                  
run;    
data beta_2 (drop=tcfee_l1 pbig_l1 psmall_l1 bigame_l1 lognsite_l1);  
set beta2;
b_tc2=tcfee_l1;                                                                                                                                
b_fish21=pbig_l1;                                                                                                                          
b_fish22=psmall_l1;                                                                                                                            
b_fish23=bigame_l1;                                                                                                                      
b_lsite2=lognsite_l1; 
inmerge=1;    
proc sort; by inmerge;                                                                                                                  
run;  
data prob_1 (keep=id_code eu1 eu2 site y inmerge);                                                                                             
merge dolphin_1 beta_1 beta_2;                                                                                                                
by inmerge;                                                                                                                             
* calculate exp of utility at each site;                                                                                                
eu1=exp(b_tc1*tc+b_fish11*pbig+b_fish12*psmall+b_fish13*bigame+b_lsite1*lognsite); 
eu2=exp(b_tc2*tc+b_fish21*pbig+b_fish22*psmall+b_fish23*bigame+b_lsite2*lognsite);  
proc sort; by id_code;                                                                                                                  
run;                                                                               
* for conditional logit, just sum over all of the exp_util;                                                                             
proc means noprint; 
var eu1 eu2; by id_code;                                                                                           
output out=denom sum=sumeu1 sumeu2;                                                                                                          
run;                                                                                                                                    
data denom_1 (keep=id_code sumeu1 sumeu2);                                                                                               
set denom;                                                                                                                              
run;                                                                                                                                    
data prob_2;                                                                                                                            
merge prob_1 denom_1;                                                                                                                   
by id_code;                                                                                                                             
prob1=eu1/sumeu1; 
prob2=eu2/sumeu2;     
proc sort; by site;                                                                                                                     
run;                                                                                                                                    
proc means data=prob_2 noprint; 
var prob1 prob2; by site;                                                                                      
output out=pred_prob(keep=site prob1 prob2) mean=prob1 prob2;                                                                                         
run;                                                                                                                                    
* now calculate means of predicted sites;                                                                                               
proc means data=prob_2 noprint; var y; by site;                                                                                         
output out=actual_prob(keep=site y) mean=y;                                                                                             
run;                                                                                                                                    
/* calculate mean squared errors */                                                                                                         
data mse;                                                                                                                               
merge pred_prob actual_prob;   
by site;                                                                                                                                
mse1sqrd =((prob1-y)**2);    
mse2sqrd =((prob2-y)**2); 
/* calculate sum of squared errors */
proc means noprint; 
var mse1sqrd mse2sqrd;       
output out=sumsqrd sum=sum_mse1 sum_mse2;   
/* calculate square root of sum of squared errors divided by number of sites */ 
data rmse; set sumsqrd;
k = _freq_;
rmse1 = (sum_mse1/k)**.5;
rmse2 = (sum_mse2/k)**.5;
proc means;
run;
